"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const compose_1 = require("../functions/compose");
class IO {
    constructor(executeUnsafeIO) {
        this.executeUnsafeIO = executeUnsafeIO;
    }
    static of(x) {
        return new IO(() => x);
    }
    map(fn) {
        return IO.of(compose_1.compose(fn, this.executeUnsafeIO));
    }
    toString() {
        return `IO(${this.executeUnsafeIO})`;
    }
}
exports.IO = IO;
//# sourceMappingURL=IO.js.map