import { Either } from './RealEither';
import { IMappable } from './interfaces/IMappable';
import { IChainable } from './interfaces/IChainable';
import { IApplicable } from './interfaces/IApplicable';
declare class Right<T> extends Either<T> implements IMappable<T>, IChainable<T>, IApplicable<T> {
    constructor($value: T);
    chain<B = T>(fn: (x: T) => B): IChainable<any>;
    join(): Right<T>;
    ap(a: IApplicable<any>): IApplicable<any>;
    static of<T>(x: T): Right<T>;
    readonly isRight: boolean;
    map<B>(fn: (x: T) => B): Right<B>;
    toString(): string;
}
export { Right };
