"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealEither_1 = require("./RealEither");
class Right extends RealEither_1.Either {
    constructor($value) {
        super($value);
    }
    chain(fn) {
        return this.map(fn).join();
    }
    join() {
        return Right.of(this.value);
    }
    ap(a) {
        return a.map(this.value);
    }
    static of(x) {
        return new Right(x);
    }
    get isRight() {
        return true;
    }
    map(fn) {
        return Right.of(fn(this.$value));
    }
    toString() {
        return `Right(${this.$value})`;
    }
}
exports.Right = Right;
//# sourceMappingURL=RealRight.js.map