"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const compose = (...fns) => result => {
    const fnList = [...fns];
    while (fnList.length > 0) {
        // take the last function off the end of the list
        // and execute it
        result = fnList.pop()(result);
    }
    return result;
};
exports.compose = compose;
//# sourceMappingURL=compose.js.map