"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const curry_1 = require("./curry");
const not_1 = require("./not");
function filter(predicate, xs) {
    const filtered = [];
    for (const [key, value] of xs.entries()) {
        if (predicate(value, key, xs)) {
            filtered.push(value);
        }
    }
    return filtered;
}
const filterOut = curry_1.curry((predicate, xs) => filter(not_1.not(predicate), xs));
exports.filterOut = filterOut;
const filterIn = curry_1.curry(filter);
exports.filterIn = filterIn;
//# sourceMappingURL=filter.js.map