"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealLeft_1 = require("../../src/algebra/RealLeft");
const composeUsingReverse_1 = require("../../src/functions/composeUsingReverse");
const identity_1 = require("../../src/functions/identity");
describe("Left is a PointedFunctor, because : ", () => {
    it(" Left.map respects the PointedFunctor identity law for Left", () => {
        const eitherOfNull = RealLeft_1.Left.of(null);
        const eitherOfNullIdentity = eitherOfNull.map(identity_1.identity);
        expect(eitherOfNull).toEqual(eitherOfNullIdentity);
        expect(eitherOfNullIdentity instanceof RealLeft_1.Left).toBe(true);
    });
    it(" Left.map respects the PointedFunctor composition law for Left", () => {
        const left = true;
        const add1 = x => x + 1;
        const mult2 = x => x * 2;
        const add1ThenMult2 = composeUsingReverse_1.composeUsingReverse(mult2, add1);
        const eitherOfNull = RealLeft_1.Left.of(null);
        expect(eitherOfNull.map(add1ThenMult2)).toEqual(eitherOfNull.map(add1).map(mult2));
        expect(eitherOfNull.map(add1ThenMult2) instanceof RealLeft_1.Left).toBe(true);
    });
});
//# sourceMappingURL=RealLeft.spec.js.map