"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealNothing_1 = require("../../src/algebra/RealNothing");
const composeUsingReverse_1 = require("../../src/functions/composeUsingReverse");
const identity_1 = require("../../src/functions/identity");
describe('Nothing<T> is a Functor because: ', () => {
    it(' Nothing<T>.map respects the Functor identity law', () => {
        const maybeOfNull = RealNothing_1.Nothing.of(null);
        expect(maybeOfNull.map(identity_1.identity)).toEqual(maybeOfNull);
    });
    it(' Nothing<T>.map respects the Functor composition law', () => {
        const add1 = x => x + 1;
        const mult2 = x => x * 2;
        const add1ThenMult2 = composeUsingReverse_1.composeUsingReverse(mult2, add1);
        const maybeOfNull = RealNothing_1.Nothing.of(null);
        expect(maybeOfNull.map(add1ThenMult2)).toEqual(maybeOfNull.map(add1).map(mult2));
        expect(maybeOfNull.map(add1ThenMult2).value).toBe(null);
    });
});
//# sourceMappingURL=RealNothing.spec.js.map