"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Functor_1 = require("../../src/examples/Functor");
const map_1 = require("../../src/functions/map");
const prop_1 = require("../../src/functions/prop");
describe("Functor: ", () => {
    it(" creating a Functor of a value returns an object that holds the value", () => {
        const pointedFunctorOf1 = new Functor_1.Functor(1);
        const getValue = prop_1.prop('$value');
        expect(map_1.map(getValue)([pointedFunctorOf1])[0]).toEqual(1);
    });
    it("Functor.map(fn) produces another Functor that holds the same value as the return value of fn applied to fn(Functor.$value) ", () => {
        const pointedFunctorOf1 = new Functor_1.Functor(1);
        const toString = x => x.toString();
        const getValue = prop_1.prop('$value');
        const pointedFunctorOfString1 = pointedFunctorOf1.map(toString);
        const valueOfFunctorOf1 = getValue(pointedFunctorOf1);
        const valueOfFunctorOfString1 = getValue(pointedFunctorOfString1);
        expect(valueOfFunctorOfString1).toEqual(toString(valueOfFunctorOf1));
    });
});
//# sourceMappingURL=Functor.spec.js.map