"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Monad_1 = require("../../src/examples/Monad");
describe('Monad: ', () => {
    it(' Respects the Left Identity Law', () => {
        const f = (x) => Monad_1.Monad.of(x.toUpperCase());
        const a = 'Hello';
        const lhs = Monad_1.Monad.of(a).chain(f);
        const rhs = f(a);
        expect(lhs).toEqual(rhs);
    });
    it(' Respects the Right Identity Law', () => {
        const f = (x) => Monad_1.Monad.of(x);
        const ma = Monad_1.Monad.of('hello');
        const rhs = ma.chain(f);
        const lhs = ma;
        expect(lhs).toEqual(rhs);
    });
    it(' Respects the Associativity Law', () => {
        const f = (x) => Monad_1.Monad.of(x.toUpperCase());
        const g = (x) => Monad_1.Monad.of(x.repeat(2));
        const ma = Monad_1.Monad.of('hello');
        const rhs = ma.chain(f).chain(g);
        const lhs = ma.chain((x) => f(x).chain(g));
        expect(lhs).toEqual(rhs);
    });
});
//# sourceMappingURL=Monad.spec.js.map