"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const compose_1 = require("../../src/functions/compose");
describe("The result of applying a function resulting from the composition of a number of functions", () => {
    it("should be the same as the result of applying the inner functions  then applying the outer function", () => {
        const add2 = x => x + 2;
        const square = x => x * x;
        const minus = x => -x;
        const addThenSquareThenMinus = compose_1.compose(minus, square, add2);
        expect(addThenSquareThenMinus(2)).toEqual(minus(square(add2(2))));
    });
});
//# sourceMappingURL=compose.spec.js.map