"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const compose_1 = require("../../src/functions/compose");
const composeWithReduceLazy_1 = require("../../src/functions/composeWithReduceLazy");
const sum = (...x) => {
    return x.reduce((x = 0, y) => x + y);
};
const minus = n => {
    const ns = [...n];
    return ns.map(x => -x);
};
const mult3 = x => {
    return x.reduce((x = 1, y) => x * y);
};
describe("composeWithReduceLazy: Writing compose using reduce", () => {
    it("should allow to compose methods of varying arity", () => {
        const composed = composeWithReduceLazy_1.composeWithReduceLazy(sum, mult3, minus);
        expect(composed([2, 3, 4])).toEqual(sum(mult3(minus([2, 3, 4]))));
    });
    it("should return the same results as compose", () => {
        const composed = composeWithReduceLazy_1.composeWithReduceLazy(sum, mult3, minus);
        expect(composed([2, 3, 4])).toEqual(compose_1.compose(sum, mult3, minus)([2, 3, 4]));
    });
});
//# sourceMappingURL=composeWithReduceLazy.spec.js.map