"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const curryProps_1 = require("../../src/functions/curryProps");
describe("A function with no parameters", () => {
    it("should behave as if it were not curried", () => {
        const fn = () => true;
        const curried = curryProps_1.curryProps(fn);
        expect(curried()).toEqual(true);
    });
});
describe("A function with one parameter", () => {
    it("should behave as if it were not curried", () => {
        const fn = (x) => x;
        const curried = curryProps_1.curryProps(fn);
        expect(curried({ x: true })).toEqual({ x: true });
    });
});
describe("A function with more than one parameter", () => {
    it("should allow the same number of successive applications  as its arity", () => {
        const fn = ({ x, y }) => [x, y];
        const curried = curryProps_1.curryProps(fn, 2);
        expect(curried({ x: 1 })({ y: 2 })).toEqual([1, 2]);
        const fn2 = ({ x, y, z }) => [x, y, z];
        const curried2 = curryProps_1.curryProps(fn2, 3);
        expect(curried2({ x: 1 })({ y: 2 })({ z: 3 })).toEqual([1, 2, 3]);
    });
});
//# sourceMappingURL=curryProps.spec.js.map