"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const filter_1 = require("../../src/functions/filter");
describe("filter: ", () => {
    it("filterIn keeps array elements if predicate is true ", () => {
        const r = [1, 2, 3, 4, 5];
        const isOdd = x => x % 2 === 1;
        const filterInOdds = filter_1.filterIn(isOdd);
        expect(filterInOdds(r)).toEqual([1, 3, 5]);
    });
    it("filterOut keeps array elements if predicate is false ", () => {
        const r = [1, 2, 3, 4, 5];
        const isOdd = x => x % 2 === 1;
        const filterOutOdds = filter_1.filterOut(isOdd);
        expect(filterOutOdds(r)).toEqual([2, 4]);
    });
});
//# sourceMappingURL=filter.spec.js.map