"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mildCurry_1 = require("../../src/functions/mildCurry");
describe("A function with no parameters", () => {
    it("should behave as if it were not mild curried", () => {
        const fn = () => true;
        const curried = mildCurry_1.mildCurry(fn);
        expect(curried()).toEqual(true);
    });
});
describe("A function with one parameter", () => {
    it("should behave as if it were not mild curried", () => {
        const fn = (x) => x;
        const curried = mildCurry_1.mildCurry(fn);
        expect(curried(true)).toEqual(true);
    });
});
describe("A function with more than one parameter", () => {
    it("should allow the same number arguments in successive applications  as its arity", () => {
        const fn = (x, y) => [x, y];
        const curried = mildCurry_1.mildCurry(fn);
        expect(curried(1, 2)).toEqual([1, 2]);
        const fn2 = (x, y, z, a, b, c) => [x, y, z, a, b, c];
        const curried2 = mildCurry_1.mildCurry(fn2);
        expect(curried2(1)(2)(3, 4)(5)(6)).toEqual([1, 2, 3, 4, 5, 6]);
    });
});
//# sourceMappingURL=mildcurry.spec.js.map