"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealLeft_1 = require("../../src/algebra/RealLeft");
const compose_1 = require("../../src/functions/compose");
const curry_1 = require("../../src/functions/curry");
const prop_1 = require("../../src/functions/prop");
const real_either_function_1 = require("../../src/functions/real-either-function");
const src_1 = require("../../src");
describe("either function: embodies disjuction by selectively applying functions f and g depending on e being Right or Left", () => {
    it("When e is Right, execute fortune", () => {
        expect(tellHimIfHegotAGift(jake)).toEqual(fortune('Address 1'));
    });
    it("When e is Left, execute misfortune", () => {
        expect(tellHimIfHegotAGift(john)).toEqual(misfortune('A Person must have an address'));
    });
});
const Person = class {
    constructor(name, addresses) {
        this.name = name;
        this.addresses = addresses;
        this.name = name;
        this.addresses = [...addresses];
    }
    isValid() {
        return this.addresses.length > 0;
    }
    toString() {
        return `this.name: ${this.name}
     this.addresses: ${this.addresses.join()}`;
    }
};
const indexAccess = curry_1.curry((f, anyIndexable) => f(anyIndexable));
const getHead = xs => indexAccess(r => r[0])(xs);
const fortune = address => `Congrats! You will recieve your gift at address: ${address}`;
const misfortune = txt => `Sorry! You will not receive anything because... ${txt}`;
function getAddress(person) {
    const getAddressesHead = compose_1.compose(getHead, prop_1.prop("addresses"));
    return person.isValid()
        ? src_1.Right.of(person).map(getAddressesHead)
        : RealLeft_1.Left.of("A Person must have an address");
}
const decideOnGift = real_either_function_1.either(misfortune)(fortune);
const tellHimIfHegotAGift = compose_1.compose(decideOnGift, getAddress);
const jake = new Person('jake', ['Address 1', 'Address 2']);
const john = new Person('john', []);
//# sourceMappingURL=real-either-function.spec.js.map